using C1.Win.FlexGrid;

namespace FlexGrid_BarButton_NET8
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // populate grid
            Random rnd = new Random();
            _flex.Rows.Count = 15;
            _flex.Rows.Fixed = 2;
            //_flex[0,1] = "Direction";
            _flex[0, 2] = _flex[1, 2] = "Region";
            CellRange rg = _flex.GetCellRange(0, 3, 1, _flex.Cols.Count - 1);
            rg.Data = "Rnd";
            _flex.AllowMergingFixed = AllowMergingEnum.Free;
            foreach (Column col in _flex.Cols)
                col.AllowMerging = true;

            for (int r = _flex.Rows.Fixed; r < _flex.Rows.Count; r++)
            {
                _flex[r, 0] = r;
                _flex[r, 1] = (r < 7) ? "Inbound" : "Outbound";
                _flex[r, 2] = (r < 3) ? "North" : (r < 7) ? "South" : (r < 10) ? "East" : "West";
                for (int c = 3; c < _flex.Cols.Count; c++)
                {
                    _flex[r, c] = rnd.Next(1000);
                    _flex.Cols[c].Format = "#,###";
                }
            }

            // set up styles
            CellStyle s = _flex.Styles[CellStyleEnum.Subtotal0];
            s.BackColor = Color.Black;
            s.ForeColor = Color.White;
            s.Font = new Font(_flex.Font, FontStyle.Bold);
            s = _flex.Styles[CellStyleEnum.Subtotal1];
            s.BackColor = Color.DarkBlue;
            s.ForeColor = Color.White;
            s = _flex.Styles[CellStyleEnum.Subtotal2];
            s.BackColor = Color.DarkRed;
            s.ForeColor = Color.White;

            // more setup
            _flex.AllowDragging = AllowDraggingEnum.None;
            _flex.AllowEditing = false;
            _flex.Cols[0].WidthDisplay /= 3;
            _flex.Tree.Column = 1;

            // show totals
            UpdateTotals();

            _flex.Tree.Style = TreeStyleFlags.CompleteLeaf;
        }

        private void UpdateTotals()
        {
            // clear existing totals
            _flex.Subtotal(AggregateEnum.Clear);

            // calculate subtotals (three levels, totals on every column)
            for (int c = 3; c < _flex.Cols.Count; c++)
            {
                _flex.Subtotal(AggregateEnum.Sum, 0, -1, c, "Grand Total");
                _flex.Subtotal(AggregateEnum.Sum, 1, 1, c, "Total for {0}");
                _flex.Subtotal(AggregateEnum.Sum, 2, 2, c, "Total for {0}");
            }

            // done, autosize columns to finish
            _flex.AutoSizeCols();
        }
    }
}
